//******************************************************************************
// Mozilla Backup
//
// - hlavni unita
//
// Programoval:         Pavel Cvrcek <jasnapaka@jasnapaka.com>
// Verze:               1.2a
// Posledni editace:    2004/01/02
//******************************************************************************

{
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
}

unit hlavni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, StdCtrls, ComCtrls, adresar, ZipMstr,
  bsPolyglotUn, heslo, heslo2;

// informace o jmenu a verzi aplikace
const NAZEV_APLIKACE = 'Mozilla Backup 1.2';
      Pocet_aplikaci = 3;

type TProgram = record
        Nalezen:      boolean;          // nalezena aplikace?
        Verze:        string;           // verze programu
        Cesta:        string;           // adresar se spustitelnym souborem
      end;

     TProfil = record                   // externi profil
        Jmeno: string;
        Cesta: string;
     end;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Image1: TImage;
    Bevel2: TBevel;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Memo1: TMemo;
    Button3: TButton;
    Panel2: TPanel;
    Memo2: TMemo;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ListBox1: TListBox;
    StaticText1: TStaticText;
    Panel3: TPanel;
    StaticText2: TStaticText;
    ListBox2: TListBox;
    GroupBox2: TGroupBox;
    StaticText3: TStaticText;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StaticText4: TStaticText;
    Button5: TButton;
    Panel4: TPanel;
    StaticText5: TStaticText;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    Panel5: TPanel;
    ListBox3: TListBox;
    StaticText6: TStaticText;
    ProgressBar1: TProgressBar;
    CheckBox9: TCheckBox;
    Panel6: TPanel;
    ListBox4: TListBox;
    Memo3: TMemo;
    Button6: TButton;
    Button7: TButton;
    ZipMaster1: TZipMaster;
    CheckBox7: TCheckBox;
    bsPolyglotTranslator1: TbsPolyglotTranslator;
    bsPolyglotManager1: TbsPolyglotManager;
    CheckBox13: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button7Click(Sender: TObject);
    procedure ZipMaster1PasswordError(Sender: TObject;
      IsZipAction: Boolean; var NewPassword: String; ForFile: String;
      var RepeatCount: Cardinal; var Action: TPasswordButton);
    procedure ZipMaster1Message(Sender: TObject; ErrCode: Integer;
      Message: String);
  private
    { Private declarations }
  public    
    Akce: byte;                         // 1 - zalohovani, 2 - obnoveni
    Okno: byte;                         // informace o tom, ktere okno je momentalne
                                        // aktualni
    Cesta: string;                      // cesta ke slozce s Mozillou
    Slozka_data: string;                // slozka s profily Mozilly
    Verze: string;                      // zjistena verze Mozilly
    Chyba: boolean;                     // vyskytla se chyba - program bude ukoncen
    Typ_programu: byte;                 // program, kter je vybrn
    Vyst_soubor: string;                // cesta k vystupnimu souboru
    Verze_souboru: byte;                // verze zalozniho souboru
    Password: string;                   // heslo
    Jazyk: integer;                     // konstanta jazykove mutace
  end;

var
  Form1: TForm1;
  Programy: array [1..Pocet_aplikaci] of TProgram;    // seznam programu, ktere se budou vyhledavat
  Externi_profil: TProfil;

implementation

{$R *.dfm}

//******************************************************************************
// Deklarace pouzitych unit
//******************************************************************************

uses funkce, okna, zaloha, language;
// funkce - pouzite funkce
// okna - informace o oknech pruvodce
// zaloha - provedeni zalohy ci obnovy profilu
 
//******************************************************************************
// Procedury a funkce
//******************************************************************************

procedure TForm1.FormCreate(Sender: TObject);
begin
  // nastaveni cesty k jazykovemu souboru
  bsPolyglotManager1.LangsDir:= ExtractFilePath (Application.ExeName);

  // nacteni jazykoveho nastaveni
  Load_language;

  // nastaveni uvodniho okna
  Okno1;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  // vyber programu, ktery se bude zalohovat
  Over_vyber;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  // volba profilu
  Over_vyber_profilu;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // ukonceni programu
  Form1.Close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Create_profil;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  // vyber souboru
  ChooseDialog;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  // Obnovit profily
  DetekceProfilu;
  Form1.Button1.Enabled:= false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Tlacitko dalsi v dialogu
  case Okno of
    1: begin
         Okno2;                 // nastaveni na dialog 2 - volba operace    
         Okno:= Okno + 1;
       end;
    2: begin
         Okno3;
         Okno:= Okno + 1;
       end;
    3: begin                    // detekce komponent pro zalohovani (obnoveni)
         Okno4;
         Okno:= Okno + 1;
       end;
    4: begin                    // akce
         if Zacatek_zalohovani = true then      // Mozilla nebyla detekovana
           begin
             Okno5;
             // provedeni zalohy ci obnovy souboru
             if ListBox2.Items.Strings[ListBox2.ItemIndex] = TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile') then
             Slozka_data:= Externi_profil.Cesta;

             if Akce = 1 then Zalohovani else Obnoveni;
             Okno:= Okno + 1;                       
           end;
       end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // Tlacitko zpet v dialogu
  case Okno of
    2: begin
         Okno:= Okno - 1;
         Okno1;                 // nastaveni na dialog 1 - uvitani
       end;
    3: begin                    // nastaveni na dialog 2 - volba operace
         Okno2;
         Okno:= Okno - 1;
       end;
    4: begin                    // nastaveni na dialog 3 - volba profilu
         Okno3;
         Okno:= Okno - 1;
       end;
    5: begin                    // nastaveni na dialog 4 - volba soucasti
         Okno4;
         Okno:= Okno - 1;
       end;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  // uzavreni formulare (eventualne zobrazeni dialogu)
  Ukonceni_programu (CanClose);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  // nalezeni externiho profilu
  Profil_okno;
  Form3.Potvrzeno:= false;
  Form3.Font.Charset:= Form1.Jazyk;

  Form3.ShowModal;

  // pridan novy profil?
  if Form3.Potvrzeno = true then Add_profil;
end;

procedure TForm1.ZipMaster1PasswordError(Sender: TObject;
  IsZipAction: Boolean; var NewPassword: String; ForFile: String;
  var RepeatCount: Cardinal; var Action: TPasswordButton);
begin
  // je vyzadovano heslo
  Form5.Edit1.Clear;
  Form5.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm5', 'LANG_CAPTION', 'Zskn hesla');
  Form5.Label1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm5', 'LANG_LABEL1', 'Zlon soubor je pod heslem. Zadejte jeho znn:');
  Form5.Label2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_HESLO', 'Password:');
  
  Form5.Button1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_OK', 'OK');
  Form5.Button2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_2', 'Cancel');   
  
  Form5.ShowModal;

  if Form5.Potvrzeno = true then
    begin
      NewPassword:= Form5.Edit1.Text;
      ZipMaster1.Password:= Form5.Edit1.Text;
    end;
end;

procedure TForm1.ZipMaster1Message(Sender: TObject; ErrCode: Integer;
  Message: String);
begin
 // chyba

end;

end.
