//******************************************************************************
// Mozilla Backup
//
// - unita slouzi k nacitani lokalizaci
//
// Programoval:         Pavel Cvrcek <jasnapaka@jasnapaka.com>
// Verze:               1.2a
// Posledni editace:    2004/01/02
//******************************************************************************

{
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
}



unit language;

interface

procedure Load_language;

implementation

uses hlavni, bsPolyglotUn, SysUtils, Dialogs;

//******************************************************************************
// procedure Load_language
//
// - nacte lokalizaci
//******************************************************************************

procedure Load_language;
var Jazykl: string;
begin
  // nacteni jazykove konstanty
  Jazykl:= (TbsCorePolyglot.GetCorePolyglot.GetString ('Common', 'DefaultCharset', '0'));
  Form1.Jazyk:= StrToInt (Jazykl);
  Form1.Font.Charset:= Form1.Jazyk;

  // jazykove nastaveni Okna 1
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_OKNO_1', ' - Welcome');
  Form1.Label1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_APLIKACE_WELCOME', 'Welcome to Mozilla Backup');
  Form1.Button1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_1', 'Next >');
  Form1.Button2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_2', 'Cancel');
  Form1.Button3.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_3', '< Back');

  // jazykove nastaveni Okna 2
  Form1.GroupBox1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_VOLBA', 'Option');
  Form1.StaticText1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CO_PROVEST', 'Choose the operation you want to perform.');
  Form1.RadioButton1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_ZALOHA', 'Backup a profile');
  Form1.RadioButton2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_OBNOVA', 'Restore a profile');

  // jazykove nastaveni Okna 3
  Form1.GroupBox2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHOOSE_FILE', 'Select the file');
  Form1.Button4.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHOOSE', 'Browse...');
  Form1.Button5.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_NEW_PROFIL', 'New profile');
  Form1.Button6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_RELOAD', 'Refresh');
  Form1.Button7.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHOOSEPROFIL', 'Find profile...');

  // nacteni MEM
  Form1.Memo1.Lines.Clear;
  Form1.Memo1.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_MEMO1', 'This wizard will help you to backup or restore your Mozilla user profile.'));
  Form1.Memo1.Lines.Add('');
  Form1.Memo1.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_MEMO11', 'It is strongly recomended that you exit all Windows programs that can be manipulated with your Mozilla user profile.'));
  Form1.Memo1.Lines.Add('');
  Form1.Memo1.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_MEMO12', 'Click Cancel to quit the program. Click Next to continue.'));

  Form1.Memo2.Lines.Clear;
  Form1.Memo2.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_MEMO2', 'It is possible to backup or restore Mozilla user profile(s) of the following application(s):'));

  Form1.Memo3.Lines.Clear;
  Form1.Memo3.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_MEMO3', 'The backup was created. You can read the report below:'));

end;

end.
