//******************************************************************************
// Mozilla Backup
//
// - unita nastavuje informace o oknech pruvodce
//
// Programoval:         Pavel Cvrcek <jasnapaka@jasnapaka.com>
// Verze:               1.2a
// Posledni editace:    2004/01/02
//******************************************************************************

{
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
}

unit okna;

interface

//******************************************************************************
// Deklarace public procedur a funkci
//******************************************************************************

// dialog c. 1 - uvitani v pruvodci
procedure Okno1;
// dialog c. 2 - volba operace
procedure Okno2;
// dialog c. 3 - volba profilu
procedure Okno3;
// dialog c. 4 - volba soucasti, ktere se budou zalohovat (obnovovat)
procedure Okno4;
// dialog c. 5 - provadeni akci
procedure Okno5;
// dialog c. 6 - zaver
procedure Okno6;


// okno na vyber externiho profilu
procedure Profil_okno;

implementation

//******************************************************************************
// Deklarace pouzitych unit
//******************************************************************************

uses adresar, hlavni, dialogs, forms, funkce, jp_windows, sysutils, windows, bsPolyglotUn, heslo, ZipMstr;

//******************************************************************************
// Procedury a funkce
//******************************************************************************


//******************************************************************************
// procedure Okno1
//
// - nastaveni 1. dialogu - uvitani
//******************************************************************************

procedure Okno1;
begin
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_OKNO_1', ' - Welcome');
  // nastaveni vystupniho souboru
  Form1.Vyst_soubor:= '';
                                         
  // nastaveni prvku na formulari
  Form1.Panel1.Visible:= true;
  Form1.Panel2.Visible:= false;
  Form1.Button1.Enabled:= true;
  Form1.Button3.Visible:= false;

  // nastaveni promennych
  Form1.Okno:= 1;
  Form1.Chyba:= false;          // chyba nenastala
  Form1.Password:= '';
end;


//******************************************************************************
// procedure Okno2
//
// - nastaveni 2. dialogu - volba operace
//******************************************************************************

procedure Okno2;
begin
  // nastaveni Caption okna
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_APLIKACE_VOLBA', ' - Operation type');

  // nastaveni prvku na formulari
  Form1.Panel3.Visible:= false;
  Form1.Panel2.Visible:= true;
  Form1.Panel1.Visible:= false;
  Form1.Button3.Visible:= true;

  DetekceKomponent;     // detekce nainstalovanych aplikaci
  Over_program;         // je detekovan nejaky program? ne - program bude ukoncen
  Over_vyber;           // overi, zda-li je vybran nejaky program na zalohovani
end;


//******************************************************************************
// procedure Okno3
//
// - nastaveni 3. dialogu - volba profilu
//******************************************************************************

procedure Okno3;
var Soubor: string;
begin
  // volba operace
  if Form1.RadioButton1.Checked then Form1.Akce:= 1 else Form1.Akce:= 2;

  // nastaveni Caption okna
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_VOLBA_PROFILU', ' - Profile selection');

  // nastaveni prvku na formulari
  if (Length (Programy[Form1.Typ_programu].Cesta) <> 0) and (Form1.Akce = 2) then
  Form1.Button5.Enabled:= true else Form1.Button5.Enabled:= false;

  Form1.Panel3.Visible:= true;
  Form1.Panel4.Visible:= false;
  Form1.Panel2.Visible:= false;
  Form1.Panel1.Visible:= false;
  Form1.Button1.Enabled:= false;  

  // nastaveni jazykovych veci
  if Form1.Akce = 1 then
    begin
      Form1.StaticText2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_TEXT2_1', 'Select the profile you want to backup.');
      Form1.StaticText4.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_TEXT4_1', 'After that, select the file to create backup in.');
      Form1.Button7.Enabled:= true;
    end
  else
    begin
      Form1.StaticText2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_TEXT2_2', 'Select the profile you want to restore.');
      Form1.StaticText4.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_TEXT4_2', 'After that, select the file to restore the profile from.');
      Form1.Button7.Enabled:= false;
    end;

  Externi_profil.Jmeno:= '';
  DetekceProfilu;               // provede detekci profilu
  Over_vyber_profilu;           // je vybran nejaky profil?

  // generovani vychoziho jmena souboru
  Soubor:= GetDefaultFileName;

  Form1.Vyst_soubor:= Soubor;

  // zobrazeni jmena souboru
  if Length (Soubor) < 40 then Form1.StaticText3.Caption:= Soubor
  else
    begin
      Form1.StaticText3.Caption:= Copy (Soubor, 1, 3) + '...' + Copy (Soubor, Length (Soubor) - 35, 36);
      Form1.StaticText3.Hint:= Soubor;
    end; 
end;


//******************************************************************************
// procedure Okno4
//
// - nastaveni 4. dialogu - volba soucasti
//******************************************************************************

procedure Okno4;
var Pokracovat: boolean;
begin
 Pokracovat:= true;

 // prepsat zalozni soubor? - pri zalohovani
 if (Form1.Akce = 1) and (FileExists (Form1.Vyst_soubor)) then
   begin
     if Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR_EXIST', 'This file already exists. Overwrite?')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_YESNO + MB_ICONWARNING) = 7 then
     Pokracovat:= false;
   end;

 // existuje zalozni soubor? - pri obnoveni profilu
 if (Form1.Akce = 2) and (not (IsValidFile (Form1.Vyst_soubor))) then
   begin
     Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_NO_BACKUP_FILE', 'The backup file wasn''t found or bad format.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
     Pokracovat:= false;
   end;

 if Pokracovat then begin

 // zaheslovat archiv? - pri zalohovani
 if (Form1.Akce=1) and (Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_ENCRYPT', 'Do you want to encrypt backup''s file?')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')),MB_YESNO + MB_ICONQUESTION) = IDYES) then
   begin
     Form4.Edit1.Clear;
     Form4.Edit2.Clear;
     Form1.Password:= '';
     Form4.Potvrzeno:= false;
     Form4.Font.Charset:= Form1.Jazyk;
     Form4.Label1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_TEXT', 'Enter the password.');
     Form4.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_CAPTION', 'Set password');
     Form4.Label2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_HESLO', 'Password:');
     Form4.Label3.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm4', 'LANG_HESLO2', 'Confirm password:');     
     Form4.Button1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_OK', 'OK');
     Form4.Button2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_2', 'Cancel'); 

     Form4.ShowModal;

     if Form4.Potvrzeno = true then
       begin
         Form1.ZipMaster1.AddOptions:=[AddEncrypt];
         Form1.Password:= Form4.Edit1.Text;
       end
     else Form1.ZipMaster1.AddOptions:= [];
   end;



 if (FileExists (Form1.Vyst_soubor)) or (Form1.RadioButton1.Checked) then
    begin
      // "vynulovani" checkboxu
      NastavCheckboxy;
      // detekce soucasti urcenych k zalohovani (ci obnoveni)
      if Form1.Akce = 1 then DetekceSoucasti else DetekceSoucastiSoubor;

      // nastaveni Caption okna
      Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUCASTI', ' - Components selection');

      // nastaveni prvku na formulari
      Form1.Panel4.Visible:= true;
      Form1.Panel5.Visible:= false;
      Form1.Panel3.Visible:= false;

      // nastaveni jazykove
      if Form1.Akce = 1 then Form1.StaticText5.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHOOSE_ZALOHA', 'Select components you want to backup.')
      else Form1.StaticText5.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHOOSE_OBNOVA', 'Select components you want to restore.');

      Form1.GroupBox3.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_GROUPBOX3', 'Components');
      Form1.CheckBox1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX1', 'General setting');
      Form1.CheckBox2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX2', 'Emails');
      Form1.CheckBox3.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX3', 'Addressbooks');
      Form1.CheckBox4.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX4', 'Bookmarks');
      Form1.CheckBox5.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX5', 'History');
      Form1.CheckBox6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX6', 'Sidebars');
      Form1.CheckBox7.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX7', 'Emails setting only');
      Form1.CheckBox8.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX8', 'User styles');
      Form1.CheckBox9.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX9', 'Saved passwords');
      Form1.CheckBox10.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX10', 'Cookies');
      Form1.CheckBox11.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX11', 'Saved forms');
      Form1.CheckBox12.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX12', 'Downloaded file list');
      Form1.CheckBox13.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CHECKBOX13', 'Certificates');

      if Form1.Akce = 2 then Form1.CheckBox7.Visible:= false;
    end
  else
    begin
      Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BAD_FILE2', 'The selected file is not valid backup file.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
      Dec (Form1.Okno);
    end;
  end   // "pokracovat"
  else Dec (Form1.Okno);
end;


//******************************************************************************
// procedure Okno5
//
// - nastaveni 5. dialogu - akce
//******************************************************************************

procedure Okno5;
begin
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROV_AKCE', ' - Processing operation');

  Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_STATICTEXT6', 'Task:');
  Form1.Panel5.Visible:= true;
  Form1.Panel4.Visible:= false;
  Form1.Button1.Visible:= false;
  Form1.Button3.Visible:= false;
end;


//******************************************************************************
// procedure Okno6
//
// - nastaveni 6. dialogu - zaver
//******************************************************************************

procedure Okno6;
var I: integer;
begin
  Form1.Caption:= NAZEV_APLIKACE + TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_ZAVER', ' - Report');
  Form1.Button2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_KONEC', 'Exit');

  // zkopirovani vysledku
  if Form1.Akce = 1 then
    begin
      for I:= 0 to Form1.ListBox3.Count - 1 do
        Form1.ListBox4.Items.Add(Form1.ListBox3.Items.Strings[i]);
    end
  else Form1.ListBox4.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFILE_RESTORED', 'Profile was restored'));

  Form1.Panel6.Visible:= true;
  Form1.Panel5.Visible:= false;

  if Form1.Akce = 2 then
    begin
      Form1.Memo3.Lines.Clear;
      Form1.Memo3.Lines.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BACKUP_RESTOR', 'The backup was restored. You can read the report below:'));
    end;

  // smazani souboru s informaci o obsahu zalozniho souboru
  if (Form1.Akce = 2) and (fileexists (GetSpecialDir (11) + 'indexfile.txt')) then SysUtils.DeleteFile (GetSpecialDir (11) + 'indexfile.txt');
end;


//******************************************************************************
// procedure Profil_okno
//
// - dialog na zalohovani externiho profilu
//******************************************************************************

procedure Profil_okno;
begin
  Form3.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFILCAP', 'Path to profile');
  Form3.Label1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_TIP', 'Choose path to your profile:');
  Form3.Button1.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_OK', 'OK');
  Form3.Button2.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BUTTON_2', 'Cancel'); 
end;

end.
