//******************************************************************************
// Mozilla Backup
//
// - unita obsahuje informace o oknech pruvodce
//
// Programoval:         Pavel Cvrcek <jasnapaka@jasnapaka.com>
// Verze:               1.2a
// Posledni editace:    2004/01/02
//******************************************************************************

{
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
}

unit zaloha;

interface

const Pocet_polozek = 13;       // pocet polozek, ktere se zalohuji + 1

// ulozi seznam zalohovanych veci
procedure CreateKomponenty (var F: textfile);
// zkopiruje soubor ze zalohy
procedure Kopie2 (var F1: textfile; Soubor: string);
// provede obnoveni zalohy
procedure Obnoveni;
// vytvori potrebne adresare v ceste
procedure VytvorAdresar (S: string);
// provede zalohu
procedure Zalohovani;


implementation

//******************************************************************************
// Deklarace pouzitych unit
//******************************************************************************

uses adresar, forms, dialogs, hlavni, funkce, chyby, okna, StrUtils,
     SysUtils, Windows, ZipMstr, bsPolyglotUn;


//******************************************************************************
// procedure Uzavrit_soubor
//
// - pokusi se uzavrit a vymazat zalozni soubor, ktery se nepovedlo vytvorit
//******************************************************************************

procedure Uzavrit_soubor (var F: textfile; Soubor: string);
begin
  try
    CloseFile (F);
    if FileExists (Soubor) then SysUtils.DeleteFile (Soubor);
  except
    on E:EInOutError do
      begin
        Form1.Chyba:= true;
        Form1.Close;
      end;
  end;
end;


//******************************************************************************
// procedure CorrectPrefs
//
// - upravi soubor prefs.js
//******************************************************************************

procedure CorrectPrefs;
var F, F2: textfile;
    S, S1, S2: string;
    I, J: integer;
    Typ: byte;
begin
  Typ:= 0;
  try
    //** uprava souboru prefs.js
    if FileExists (Form1.Slozka_data + '\' + 'prefs.zal') then SysUtils.DeleteFile (Form1.Slozka_data + '\' + 'prefs.zal');
    if RenameFile (Form1.Slozka_data + '\' + 'prefs.js', Form1.Slozka_data + '\' + 'prefs.zal') then
      begin
        AssignFile (F, Form1.Slozka_data + '\' + 'prefs.zal');
        AssignFile (F2, Form1.Slozka_data + '\' + 'prefs.js');
        Reset (F);
        Rewrite (F2);

        Repeat
          Readln (F, S);
          S:= Trim (S);

          // odstraneni informaci o emailu
          if (Form1.CheckBox2.Checked = false) and (Pos ('user_pref("mail.', S) > 0) then S:= '';
          if (Form1.CheckBox2.Checked = false) and (Pos ('user_pref("mailnews.', S) > 0) then S:= '';

          // odstraneni informaci o kontaktech
          if (Form1.CheckBox3.Checked = false) and (Pos ('user_pref("ldap_2', S) > 0) then S:= '';

          // odstraneni hesel
          if (Form1.CheckBox9.Checked = false) and (Pos ('user_pref("signon.SignonFileName",', S) > 0) then S:= '';

          // doplnene formulare
          if (Form1.CheckBox11.Checked = false) and (Pos ('user_pref("wallet.SchemaValueFileName"', S) > 0) then S:= '';
          if (Form1.CheckBox11.Checked = false) and (Pos ('user_pref("wallet.caveat",', S) > 0) then S:= '';          

          // odstraneni diskove cache
          if Pos ('user_pref("browser.cache.disk.parent_directory"', S) > 0 then S:= '';
            
          // smazani cesty k emailum
          if (Pos ('user_pref("mail.root.', S) > 0) then
            begin
              if Pos ('ImapMail', S) > 0 then Typ:= 1;
              if Pos ('News', S) > 0 then Typ:= 2;
              if (Pos ('Mail', S) > 0) and (Pos ('ImapMail', S) = 0) then Typ:= 3;
              Delete (S, 30, Length (S) - 32);
              if Typ = 1 then S1:= Form1.Slozka_data + '\ImapMail';
              if Typ = 2 then S1:= Form1.Slozka_data + '\News';
              if Typ = 3 then S1:= Form1.Slozka_data + '\Mail';              
              S1:= AnsiReplaceStr (S1, '\', '\\');
              Insert (S1, S, 30);
            end;
          if (Pos ('user_pref("mail.newsrc_root"', S) > 0) then
            begin
              Delete (S, 32, Length (S) - 34);
              S1:= Form1.Slozka_data + '\News';
              S1:= AnsiReplaceStr (S1, '\', '\\');
              Insert (S1, S, 32);
            end;
            
          if ((Pos ('user_pref("mail.server.server', S) > 0) and (Pos ('.directory",', S) > 0)) then
            begin
              // zjisteni typu
              Typ:= 0;
              if Pos ('ImapMail', S) > 0 then Typ:= 1;
              if Pos ('News', S) > 0 then Typ:= 2;
              if (Pos ('Mail', S) > 0) and (Pos ('ImapMail', S) = 0) then Typ:= 3;
              
              // Nejdrive naleznu 3. uvozovku
              I:= 0; J:= 0;
              While (I < 3) do
                begin
                  Inc (J);
                  if S[J] = '"' then Inc (I);
                end;
              S1:= Copy (S, J+1, Length (S) - J - 3);
              Delete (S, J+1, Length (S) - J - 3);
              // nalezeni cesty
              I:= 1; S2:= '';
              While (I <= Length (S1)) do
                begin
                  if S1[I] <> '\' then S2:= S2 + S1[I]
                  else
                    begin   // nalezeno \
                      S2:= '';
                      Inc (I);
                    end;
                  Inc (I);
                end;

              if Typ = 1 then S2:= Trim (Form1.Slozka_data + '\ImapMail\' + S2);
              if Typ = 2 then S2:= Trim (Form1.Slozka_data + '\News\' + S2);
              if Typ = 3 then S2:= Trim (Form1.Slozka_data + '\Mail\' + S2);

              S2:= AnsiReplaceStr (S2, '\', '\\');
              Insert (S2, S, J+1);
            end;                                                    

          if Length (S) <> 0 then Writeln (F2, S);
        Until Eof (F);
      CloseFile (F2);
      CloseFile (F);
      SysUtils.DeleteFile (Form1.Slozka_data + '\' + 'prefs.zal');
  end;
  except
    on E:EInOutError do     // nastala nejaka vyjimka
      begin
        Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_NOT_FOUND2', 'A critical error occurred while accessing the file. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Halt (1);
      end;
  end;
end;


//******************************************************************************
// procedure CreateFileHeader
//
// - vytvoreni indexoveho souboru archivu
//******************************************************************************

procedure CreateFileHeader;
var F: textfile;
begin
  try
    AssignFile (F, Form1.Slozka_data + '\indexfile.txt');
    Rewrite (F);
      Writeln (F, 'Mozilla Backup');
      Writeln (F, 'Revize: ' + IntToStr (Form1.Typ_programu));
      Writeln (F, 'Verze: ' + Form1.Verze);
      Writeln (F, '****////\\\\****');
      CreateKomponenty (F);
    CloseFile (F);
    Form1.ZipMaster1.FSpecArgs.Append ('indexfile.txt');
    Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
    Form1.ZipMaster1.Add;
    SysUtils.DeleteFile (Form1.Slozka_data + '\indexfile.txt');
  except
    on E:EInOutError do
      begin
        Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WRITE_ERROR', 'The program can not write in the backup file. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Uzavrit_soubor (F, Form1.StaticText3.Caption); 
        Halt (1);
      end;
  end;
end;

//******************************************************************************
// procedure CreateKomponenty
//
// - ulozi do zalozniho souboru informaci o castech, ktere obsahuje
//
// Vstup: F - odkaz na vystupni soubor
//******************************************************************************

procedure CreateKomponenty (var F: textfile);
begin
  try
    if Form1.CheckBox1.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox2.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox3.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox4.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox5.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox6.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox8.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox9.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox10.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox11.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox12.Checked then Write (F, 'Y') else Write (F, 'N');
    if Form1.CheckBox13.Checked then Writeln (F, 'Y') else Writeln (F, 'N');
    Writeln (F, '****////\\\\****');
  except
    on E:EInOutError do
      begin
        Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WRITE_ERROR', 'The program can not write in the backup file. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Uzavrit_soubor (F, Form1.StaticText3.Caption); 
        Halt (1);
      end;
  end;
end;




//******************************************************************************
// procedure Kopie2
//
// - zkopiruje soubor ze zalohy do urcene slozky
//
// Vstup: F1 - odkaz na zdrojovy soubor
//        Soubor - jmeno vystupniho souboru
//******************************************************************************

procedure Kopie2 (var F1: textfile; Soubor: string);
var F: textfile;
    S: string;
    I: integer;
    Detekce: boolean;
begin
  Detekce:= false; I:= 0;
  try
    AssignFile (F, Form1.Slozka_data + '\' + Soubor);
    Rewrite (F);
      Repeat
        Inc (I);
        Readln (F1, S);
        if S <> '****////\\\\****' then Writeln (F, S);
        if I mod 100 = 0 then
          begin
            Application.ProcessMessages;
            While (IsRunning) and (Detekce = false) do
              begin
                case Form1.Typ_programu of
                  1: if Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_MOZILLA', 'The Mozilla (Netscape) program is running. Exit it and click the Again button.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'LANG_WARNING')), MB_RETRYCANCEL + MB_ICONERROR) = IDCANCEL then Detekce:= true;
                  2: if Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_FIREBIRD', 'The Mozilla Firebird program is running. Exit it and click the Again button.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'LANG_WARNING')), MB_RETRYCANCEL + MB_ICONERROR) = IDCANCEL then Detekce:= true;
                  3: if Application.MessageBox(pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_THUNDERBIRD', 'The Mozilla Thunderbird program is running. Exit it and click the Again button.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'LANG_WARNING')), MB_RETRYCANCEL + MB_ICONERROR) = IDCANCEL then Detekce:= true;
                end;
              end;
            if Detekce = true then
              begin
                case Form1.Typ_programu of
                  1: Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_MOZILLA2', 'You must exit the Mozilla (Netscape) program before backing up. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
                  2: Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_FIREBIRD2', 'You must exit the Mozilla Firebird program before backing up. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
                  3: Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DETEKCE_THUNDERBIRD2', 'You must exit the Mozilla Thunderird program before backing up. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
                end;
                Halt (1);
              end;
          end;
      Until S = '****////\\\\****';
    CloseFile (F);
  except
    on E:EInOutError do
      begin
        if Eof (F1) then Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_END_FILE', 'The backup file is corrupted.  The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING)
        else Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WRITE_ERROR2', 'Some files can not be restored. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Halt (1);
      end;
  end;
end;

//******************************************************************************
// procedure KopieDir
//
// - zkopiruje adresar a vsechny soubory v nem do zalozniho souboru
//
// Vstup:  Adresar - adresar do ktereho chcete kopirovat
//        Typ - typ adresare
//******************************************************************************

procedure KopieDir (Adresar: string; Typ: string);
var SearchRec: TSearchRec;
begin
  if FindFirst (Form1.Slozka_data + '\' + Adresar + '\*.*', faAnyFile, SearchRec) = 0 then
    begin
      Repeat
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
          begin
            //if SearchRec.Attr = $00000010 then  // jedna se o adresar
            if DirectoryExists (Form1.Slozka_data + '\' + Adresar + '\' + SearchRec.Name) = true then
              begin
                KopieDir (Adresar + '\' + SearchRec.Name, Typ);
              end
            else if FileExists (Form1.Slozka_data + '\' + Adresar + '\' + SearchRec.Name) = true then         // jedna se o soubor
              begin
                Form1.ZipMaster1.FSpecArgs.Append (Adresar + '/' + SearchRec.Name);
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
              end;
          end;
      Until FindNext (SearchRec) <> 0;
    end;
  SysUtils.FindClose (SearchRec);
end;


//******************************************************************************
// procedure Obnoveni
//
// - obnoveni profilu ze zalohy
//******************************************************************************

procedure Obnoveni;
var F: textfile;
    I: integer;
    S, S1: string;
    Vyhledej: TSearchRec;
begin
//  ShowMessage (Form1.Vyst_soubor);

  if FileExists (Form1.Vyst_soubor) then
    begin
      try
        // zjisteni cesty k profilu
        Form1.Slozka_data:= Form1.Slozka_data + '\Profiles\' + Form1.ListBox2.Items.Strings[Form1.ListBox2.ItemIndex];
        FindFirst (Form1.Slozka_data + '\*.*', faDirectory, Vyhledej);
        While (Vyhledej.Name = '.') or (Vyhledej.Name = '..') do
          FindNext (Vyhledej);
          
        if Length (Vyhledej.Name) > 0 then
          begin
            // doplneni cesty k profilu
            Form1.Slozka_data:= Form1.Slozka_data + '\' + Vyhledej.Name;


          if Form1.Verze_souboru = 1 then begin
            // otevreni souboru pro cteni
            AssignFile (F, Form1.Vyst_soubor);
              Reset (F);
                // nacteni prvnich 6 radku
                for I:= 1 to 6 do
                  Readln (F, S);
                // nacitani radku
                Repeat
                  Readln (F, S);
                  S:= Trim (S);

                  // obecne nastaveni
                  if (S = 'Nastaveni') and (Form1.CheckBox1.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_OBECNE1', 'Task: Restoring general setting');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;
                                                      // TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile');
                  // mail
                  if (S = 'Mail') and (Form1.CheckBox2.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_MAIL1', 'Task: Restoring emails');
                      Readln (F, S);     // nacteni jmena souboru
                      VytvorAdresar (S); // vytvori potrebne adresare
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // kontakty
                  if (S = 'Kontakty') and (Form1.CheckBox3.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_KONTATKY1', 'Task: Restoring addressbooks');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // oblibene polozky
                  if (S = 'Oblibene polozky') and (Form1.CheckBox4.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_FAVORITES1', 'Task: Restoring bookmarks');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // historie
                  if (S = 'Historie') and (Form1.CheckBox5.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_HISTORIE1', 'Task: Restoring history');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // postranni panely
                  if (S = 'Postranni panely') and (Form1.CheckBox6.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PANELY1', 'Task: Restoring sidebars');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // Uzivatelske styly
                  if (S = 'Uzivatelske styly') and (Form1.CheckBox8.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_STYLY1', 'Task: Restoring user styles');
                      Readln (F, S);     // nacteni jmena souboru
                      VytvorAdresar (S); // vytvori potrebne adresare
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // ulozena hesla
                  if (S = 'Ulozena hesla') and (Form1.CheckBox9.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_HESLA1', 'Task: Restoring saved passwords');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // cookies
                  if (S = 'Cookies') and (Form1.CheckBox10.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_COOKIES1', 'Task: Restoring cookies');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // doplnene formulare
                  if (S = 'Doplnene formulare') and (Form1.CheckBox11.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_FORMULAR1', 'Task: Restoring saved forms');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;

                  // stahovani souboru
                  if (S = 'Download manager') and (Form1.CheckBox12.Checked = true) then
                    begin
                      Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DOWNLOAD1', 'Task: Restoring downloaded file list');
                      Readln (F, S);     // nacteni jmena souboru
                      Readln (F, S1);
                      Kopie2 (F, S);     // vytvoreni souboru a jeho zkopirovani
                      Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                      Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_SOUBOR', 'Restored file: ') + S);
                    end;
                Until Eof (F);
            CloseFile (F);
         end;

      if Form1.Verze_souboru = 2 then
        begin
          Form1.ZipMaster1.ZipFileName:= Form1.Vyst_soubor;
                  
          // obnoveni nastaveni
          if Form1.CheckBox1.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_OBECNE1', 'Task: Restoring general setting'));

              Form1.ZipMaster1.FSpecArgs.Add('prefs.js');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Add('cookperm.txt');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('mimeTypes.rdf');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('user.js');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('ac-weights.txt');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              // rozestaveni prvku v okne
              Form1.ZipMaster1.FSpecArgs.Append ('localstore.rdf');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              // obnova uzivatelskeho slovniku
              Form1.ZipMaster1.FSpecArgs.Append ('persdict.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              // vyhledavaci pluginy
              Form1.ZipMaster1.FSpecArgs.Append ('search.rdf');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // obnoveni posty
          if Form1.CheckBox2.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_MAIL1', 'Task: Restoring emails'));

              Form1.ZipMaster1.FSpecArgs.Append ('mailViews.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('panacea.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('training.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              // obnoveni samotnych kont
              Form1.ZipMaster1.FSpecArgs.Append ('Mail/*.*');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('ImapMail/*.*');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('News/*.*');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;                      
            end;

          // obnoveni kontaktu
          if Form1.CheckBox3.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_KONTATKY1', 'Task: Restoring addressbooks'));

              Form1.ZipMaster1.FSpecArgs.Append ('*.mab');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // obnoveni oblibenych polozek
          if Form1.CheckBox4.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_FAVORITES1', 'Task: Restoring bookmarks'));

              Form1.ZipMaster1.FSpecArgs.Append ('bookmarks.html');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // obnoveni historie
          if Form1.CheckBox5.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_HISTORIE1', 'Task: Restoring history'));

              Form1.ZipMaster1.FSpecArgs.Append ('history.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('url-data.txt');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // sidebary
          if Form1.CheckBox6.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PANELY1', 'Task: Restoring sidebars'));

              Form1.ZipMaster1.FSpecArgs.Append ('panels.rdf');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // uzivatelske styly
          if Form1.CheckBox8.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_STYLY1', 'Task: Restoring user styles'));

              Form1.ZipMaster1.FSpecArgs.Append ('chrome/userContent.css');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('chrome/userChrome.css');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // ulozena hesla
          if Form1.CheckBox9.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_HESLA1', 'Task: Restoring saved passwords'));

              Form1.ZipMaster1.FSpecArgs.Append ('*.s');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // cookies
          if Form1.CheckBox10.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_COOKIES1', 'Task: Restoring cookies'));

              Form1.ZipMaster1.FSpecArgs.Append ('cookies.txt');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // formulare
          if Form1.CheckBox11.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_FORMULAR1', 'Task: Restoring saved forms'));

              Form1.ZipMaster1.FSpecArgs.Append ('*.w');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('formhistory.dat');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('URL.tbl');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // download
          if Form1.CheckBox12.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DOWNLOAD1', 'Task: Restoring downloaded file list'));

              Form1.ZipMaster1.FSpecArgs.Append ('downloads.rdf');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;

          // certifikaty
          if Form1.CheckBox13.Checked = true then
            begin
              Form1.ListBox3.Items.Add (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CERTIF1', 'Task: Restoring certificates'));
              
              Form1.ZipMaster1.FSpecArgs.Append ('cert7.db');
              Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('cert8.db');
              Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('key3.db');
              Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            
              Form1.ZipMaster1.FSpecArgs.Append ('secmod.db');
              Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('cert7.dir/*.*');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;

              Form1.ZipMaster1.FSpecArgs.Append ('cert8.dir/*.*');
              Form1.ZipMaster1.ExtrBaseDir:= Form1.Slozka_data;
              Form1.ZipMaster1.Extract;
            end;
        end;

        // oprava souboru prefs.js
        CorrectPrefs;
            
          end;
      except
       // nastala nejaka vyjimka
       on E:EInOutError do
         begin
          Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_KONEC', 'An error occurred while backing up some files. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
          Halt (1);
         end;
        end;
    end
  else
    begin
      Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_NOT_FOUND_FILE', 'The backup file wasn''t found. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
      Halt (1);
    end;
    
  // presun na okno 6
  Okno6;
end;


//******************************************************************************
// function PravostProfilu
//
// - detekuje, zda-li se v adresari skutecne nachazi profil Mozilly
//
// Vstup: adresar - adresar s profilem
// Vystup: - informace o tom, zda-li se jedna o profil ci nikoliv
//******************************************************************************

function PravostProfilu (Adresar: string): boolean;
begin
  if FileExists (Adresar + '\prefs.js') = false then Result:= false else Result:= true; 
end;


//******************************************************************************
// procedure VytvorAdresar
//
// - vytvori potrebne adresare v ceste
//
// Vstup: S - cesta
//******************************************************************************

procedure VytvorAdresar (S: string);
var Adresar: string;
    I: byte;
begin
  Adresar:= '';
  for I:= 1 to Length (S) do
    begin
      if S[i] <> '\' then Adresar:= Adresar + S[i]
      else
        begin
          try
            if DirectoryExists (Form1.Slozka_data + '\' + Adresar) = false
            then CreateDir (Form1.Slozka_data + '\' + Adresar);
            Adresar:= Adresar + '\';
          except
            on E:EInOutError do
              begin
                Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_DIR_ERROR', 'Creation of the directory did not succeed. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
                Halt (1);
              end;
          end;
        end;
    end;
end;


//******************************************************************************
// procedure Zalohovani
//
// - zalohovani profilu
//******************************************************************************

procedure Zalohovani;
var              // ukazatel na textovy soubor
    Vyhledej: TSearchRec;
    Profil_nalezen: boolean;
begin
  Profil_nalezen:= false;
  try

    if Form1.ListBox2.Items.Strings[Form1.ListBox2.ItemIndex] <> TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile') then
      begin
        Form1.Slozka_data:= Form1.Slozka_data + '\Profiles\'
                            + Form1.ListBox2.Items.Strings[Form1.ListBox2.ItemIndex];

        if FindFirst (Form1.Slozka_data + '\*.*', faDirectory, Vyhledej) = 0 then
          begin
            Repeat
              if FileExists (Form1.Slozka_data + '\' + Vyhledej.Name + '\prefs.js') = true then Profil_nalezen:= true;
            Until (Profil_nalezen = true) or (FindNext (Vyhledej) <> 0);

          end;
      end
    else
      begin
        Form1.Slozka_data:= Form3.ShellTreeView1.Path;
        Vyhledej.Name:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile');
      end;

    if (Length (Vyhledej.Name) > 0) and ((Vyhledej.Name = TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile')) or (PravostProfilu (Form1.Slozka_data + '\' + Vyhledej.Name))) then
      begin
        // ** zacatek zalohovani jednotlivych casti
        if Vyhledej.Name <> TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_PROFIL_NAME', 'External profile') then Form1.Slozka_data:= Form1.Slozka_data + '\' + Vyhledej.Name;

        // ** zacatek zalohovani - nastaveni zip souboru

        // existuje soubor pod stejnym jmenem?
        if FileExists (Form1.Vyst_soubor) then SysUtils.DeleteFile (Form1.Vyst_soubor);

        Form1.ZipMaster1.ZipFileName:= Form1.Vyst_soubor;
        with Form1.ZipMaster1 do
        AddOptions := AddOptions + [AddRecurseDirs, AddDirNames];

        // ** zaheslovani archivu
        if Length (Form1.Password) > 0 then Form1.ZipMaster1.Password:= Form1.Password;

        // ** vytvoreni indexoveho souboru
        CreateFileHeader;

        // ** zalohovani obecneho nastaveni
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_OBECNE', 'Task: Backing up general setting');
        if (Form1.CheckBox1.Checked) and (FileExists (Form1.Slozka_data + '\prefs.js')) then
          begin
            // zakladni konfiguracni soubor
            Form1.ZipMaster1.FSpecArgs.Append ('prefs.js');
            //Form1.ZipMaster1.Password:=
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // povolena cookie a obrazky
            Form1.ZipMaster1.FSpecArgs.Append ('cookperm.txt');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // nastaveni mime typu
            Form1.ZipMaster1.FSpecArgs.Append ('mimeTypes.rdf');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;            

            // nastaveni uzivatelskeho nastaveni
            Form1.ZipMaster1.FSpecArgs.Append ('user.js');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // doplnovani URL na zaklade uzivatele - automaticky se uci
            Form1.ZipMaster1.FSpecArgs.Append ('ac-weights.txt');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // rozestaveni prvku v okne
            Form1.ZipMaster1.FSpecArgs.Append ('localstore.rdf');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // zalohovani uzivatelskeho slovniku
            Form1.ZipMaster1.FSpecArgs.Append ('persdict.dat');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            // vyhledavaci pluginy
            Form1.ZipMaster1.FSpecArgs.Append ('search.rdf');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_OBECNE_OK', 'General setting backup... OK'));
            Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
          end;

        // ** zalohovani kontaktu
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_KONTAKTY', 'Task: Backing up addressbooks');
        if Form1.CheckBox3.Checked then
          begin
            if FindFirst (Form1.Slozka_data + '\*.mab', faAnyFile, Vyhledej) = 0 then
              begin
                if (Vyhledej.Name <> '.') and (Vyhledej.Name <> '..') then
                  begin
                    Repeat
                      Form1.ZipMaster1.FSpecArgs.Append (Vyhledej.Name);
                      Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                      Form1.ZipMaster1.Add;
                    Until FindNext (Vyhledej) <> 0;
                    SysUtils.FindClose (Vyhledej);
                    Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_KONTAKTY_OK', 'Addressbooks backup... OK'));
                    Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                  end;
              end;
          end;

        // ** zalohovani oblibenych polozek
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_FAVORITES', 'Task: Backing up bookmarks');
        if Form1.CheckBox4.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\bookmarks.html') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('bookmarks.html');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
                Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_FAVORITES_OK', 'Bookmarks backup... OK'));
                Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
              end;
          end;

        // ** zalohovani historie
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_HISTORIE', 'Task: Backing up history');
        if Form1.CheckBox5.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\history.dat') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('history.dat');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
              end;
            if FileExists (Form1.Slozka_data + '\url-data.txt') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('url-data.txt');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
              end;
            Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_HISTORIE_OK', 'History backup... OK'));
            Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
          end;

        // ** zalohovani postrannich panelu
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_PANELY', 'Task: Backing up sidebars');
        if Form1.CheckBox6.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\panels.rdf') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('panels.rdf');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
                Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_PANELY_OK', 'Sidebars backup... OK'));
                Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
              end;
          end;

        // ** zalohovani uzivatelskych stylu
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_STYLY', 'Task: Backing up user styles');
        if Form1.CheckBox8.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\chrome\userContent.css') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('chrome/userContent.css');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
              end;
            if FileExists (Form1.Slozka_data + '\chrome\userChrome.css') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('chrome/userChrome.css');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
              end;
            Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_STYLY_OK', 'User styles backup... OK'));
            Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
          end;

        // ** ulozena hesla
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_HESLA', 'Task: Backing up passwords');
        if Form1.CheckBox9.Checked then
          begin
            if FindFirst (Form1.Slozka_data + '\*.s', faAnyFile, Vyhledej) = 0 then
              begin
                if (Vyhledej.Name <> '.') and (Vyhledej.Name <> '..') then
                  begin
                    Repeat
                      Form1.ZipMaster1.FSpecArgs.Append (Vyhledej.Name);
                      Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                      Form1.ZipMaster1.Add;
                    Until FindNext (Vyhledej) <> 0;
                    SysUtils.FindClose (Vyhledej);
                    Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_HESLA_OK', 'Password Backup ... OK'));
                    Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                  end;
              end;
          end;

        // ** cookies
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_COOKIES', 'Task: Backing up cookies');
        if Form1.CheckBox10.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\cookies.txt') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('cookies.txt');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
                Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_COOKIES_OK', 'Cookies backup... OK'));
                Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
              end;
          end;

        // ** doplnene formulare
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_FORMULARE', 'Task: Backing up saved forms');
        if Form1.CheckBox11.Checked then
          begin
            if FindFirst (Form1.Slozka_data + '\*.w', faAnyFile, Vyhledej) = 0 then
              begin
                if (Vyhledej.Name <> '.') and (Vyhledej.Name <> '..') then
                  begin
                    Repeat
                      Form1.ZipMaster1.FSpecArgs.Append (Vyhledej.Name);
                      Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                      Form1.ZipMaster1.Add;
                    Until FindNext (Vyhledej) <> 0;
                    SysUtils.FindClose (Vyhledej);
                    Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_FORMULARE_OK', 'Saved forms backup... OK'));
                    Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
                  end;
              end;

            // nastaveni historie formularu
            Form1.ZipMaster1.FSpecArgs.Append ('formhistory.dat');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;              

            Form1.ZipMaster1.FSpecArgs.Append ('URL.tbl');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;   
          end;

        // ** download manager
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_SOUBORY', 'Task: Backing up downloaded file list');
        if Form1.CheckBox12.Checked then
          begin
            if FileExists (Form1.Slozka_data + '\downloads.rdf') then
              begin
                Form1.ZipMaster1.FSpecArgs.Append ('downloads.rdf');
                Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
                Form1.ZipMaster1.Add;
                Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_SOUBORY_OK', 'Downloaded file list backup... OK'));
                Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
              end;
          end;

        // ** certifikaty
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_CERTIF', 'Task: Backing up certificates');
        if Form1.CheckBox13.Checked then
          begin
            Form1.ZipMaster1.FSpecArgs.Append ('cert7.db');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            Form1.ZipMaster1.FSpecArgs.Append ('cert8.db');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            Form1.ZipMaster1.FSpecArgs.Append ('key3.db');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;
            
            Form1.ZipMaster1.FSpecArgs.Append ('secmod.db');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            if DirectoryExists (Form1.Slozka_data + '\cert7.dir') then
              begin
                KopieDir ('cert7.dir', 'Cert');
              end;

            if DirectoryExists (Form1.Slozka_data + '\cert8.dir') then
              begin
                KopieDir ('cert8.dir', 'Cert');
              end;

            Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_CERTIF_OK', 'Certificates... OK'));
            Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;              
          end;

        // ** mail
        Form1.StaticText6.Caption:= TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_MAIL', 'Task: Backing up emails');
        if Form1.CheckBox2.Checked then
          begin
            Form1.ZipMaster1.FSpecArgs.Append ('mailViews.dat');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            Form1.ZipMaster1.FSpecArgs.Append ('panacea.dat');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;

            Form1.ZipMaster1.FSpecArgs.Append ('training.dat');
            Form1.ZipMaster1.RootDir:= Form1.Slozka_data;
            Form1.ZipMaster1.Add;                 

            if Form1.CheckBox7.Checked = false then
              begin
                if DirectoryExists (Form1.Slozka_data + '\Mail') then
                  begin
                    KopieDir ('Mail', 'Mail');
                  end;
                if DirectoryExists (Form1.Slozka_data + '\ImapMail') then
                  begin
                    KopieDir ('ImapMail', 'Mail');
                  end;
                if DirectoryExists (Form1.Slozka_data + '\News') then
                  begin
                    KopieDir ('News', 'Mail');
                  end;
              end;

              Form1.ListBox3.Items.Add(TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_AKCE_MAIL_OK', 'Emails backup... OK'));
              Form1.ProgressBar1.Position:= Form1.ProgressBar1.Position + 10;
            end;
      end
    else
      begin
        // profil nebyl nalezen
        Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_BAD_DIRECTORY', 'Directory with profile not found. Backup fails.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Halt (1);
      end;

  except
     on E:EInOutError do
       begin
        Application.MessageBox (pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_KONEC', 'An error occurred while backing up some files. Either the disk is full or you don''t have write permission. The program will exit.')), pchar (TbsCorePolyglot.GetCorePolyglot.GetString ('TForm1', 'LANG_WARNING', 'Warning')), MB_OK + MB_ICONWARNING);
        Halt (1);
       end;
  end;

  // presun na posledni stranku programu}
  Okno6;
end;

end.
